import { world, system } from "@minecraft/server";

world.afterEvents.entitySpawn.subscribe((event) => {
    const entity = event.entity;
    const nearbyPlayers = entity.dimension.getEntities({
        type: "minecraft:player",
        location: entity.location,
        maxDistance: 10,
    });

    if (nearbyPlayers.length > 0) {
        const player = nearbyPlayers[0];
        const playerPos = player.location;

        if (entity.typeId === "bridge:attack1") {
            entity.runCommand(`setblock ${playerPos.x} ${playerPos.y} ${playerPos.z} flowing_lava`);
            entity.runCommand(`setblock ${playerPos.x} ${playerPos.y + 150} ${playerPos.z} anvil`);
            entity.runCommand(`effect @p slowness 10 10`);
            entity.kill();
        } else if (entity.typeId === "bridge:attack2") {
            entity.runCommand(`fill ${playerPos.x + 5} ${playerPos.y} ${playerPos.z + 5} ${playerPos.x - 5} ${playerPos.y - 5} ${playerPos.z - 5} air`);
            entity.runCommand(`fill ${playerPos.x + 5} ${playerPos.y} ${playerPos.z + 5} ${playerPos.x - 5} ${playerPos.y - 2} ${playerPos.z - 5} web`);
            entity.runCommand(`fill ${playerPos.x + 5} ${playerPos.y - 5} ${playerPos.z + 5} ${playerPos.x - 5} ${playerPos.y - 5} ${playerPos.z - 5} lava`);
            entity.runCommand(`setblock ${playerPos.x} ${playerPos.y + 150} ${playerPos.z} anvil`);
            entity.runCommand(`effect @p mining_fatigue 10 10`);
            entity.kill();
        } else if (entity.typeId === "bridge:attack3") {
            entity.runCommand(`effect @p instant_damage 5 0`);
            entity.runCommand(`effect @e[type=bridge:bill_cipher] instant_heal 5 0`);
            entity.kill();
        } else if (entity.typeId === "bridge:on_hit") {
            entity.kill();
        } else if (entity.typeId === "bridge:bill_cipher") {
            entity.runCommand(`kill @e[type=bridge:bill_cipher_statue]`);
        }
    }
});

world.afterEvents.entityDie.subscribe((event) => {
    const bill = event.deadEntity;
    if (bill.typeId === "bridge:red_bill_cipher") {
        bill.runCommand(`summon lightning_bolt ~ ~ ~`);
        bill.runCommand(`summon bridge:bill_cipher_statue ~ ~ ~`);
    }
});
world.afterEvents.entityHealthChanged.subscribe((event) => {
    const bill = event.entity;
    
    if (bill && bill.typeId === "bridge:bill_cipher_default") {
        const bill_old_hp = event.oldValue;
        const bill_new_hp = event.newValue;

        if (bill_new_hp < 2) {
            if (typeof bill.triggerEvent === "function") {
                bill.triggerEvent("stage_2_bill");
            }
        }
    }
   
});
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon") {
        summon1.triggerEvent("summon6") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_7") {
        summon1.triggerEvent("summon7") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_8") {
        summon1.triggerEvent("summon8") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_9") {
        summon1.triggerEvent("summon9") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_10") {
        summon1.triggerEvent("summon10") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_11") {
        summon1.triggerEvent("summon11") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_12") {
        summon1.triggerEvent("summon12") 
    }
}));
world.afterEvents.entitySpawn.subscribe((event => {
    const summon1 = event.entity
    if (summon1 && summon1.typeId === "bridge:bill_cipher_summon_13") {
        summon1.triggerEvent("summon13") 
    }
}));
world.afterEvents.entityHealthChanged.subscribe((event) => {
    const bill = event.entity;
    
    if (bill && bill.typeId === "bridge:fire_bill_cipher") {
        const bill_old_hp = event.oldValue;
        const bill_new_hp = event.newValue;

        if (bill_new_hp < 2) {
            if (typeof bill.triggerEvent === "function") {
                bill.triggerEvent("mad_bill");
            }
        }
    }
   
});